<ion-card>
  <ion-card-content>
    <ion-button (click)="editTitleAndDescription()" float-right ngbTooltip="Titel, Beschreibung oder Lösung bearbeiten" container="body" placement="top" [openDelay]="1000">
      <ion-icon name="create"> </ion-icon>
    </ion-button>
    <ion-card-title [ngbTooltip]="riddle.title" container="body" placement="top" [openDelay]="1000">{{ riddle.title }}</ion-card-title>
    <p> {{ riddle.description }} </p>
    <p> Lösung: {{ riddle.solution }} </p>
    <ion-item-divider>
      <ion-label ngbTooltip="Diese Rätsel müssen gelöst sein, bevor das Rätsel freigeschaltet wird" container="body" placement="top" [openDelay]="1000">
        Abhängigkeiten
      </ion-label>
    </ion-item-divider>
    <ion-select [disabled]="riddle.possPredecessors.length===0" placeholder="Keine Abhängigkeiten" multiple="true"
      cancelText="Abbrechen" okText="OK" (ngModelChange)="onPredecessorSelectionChanged($event)"
      [(ngModel)]="predecessors">
      <ion-select-option *ngFor="let pred of riddle.possPredecessors" [value]="pred.id">
        {{ pred.title }}
      </ion-select-option>
    </ion-select>
    <ion-item-divider>
      <ion-label ngbTooltip="Verfügbare Hinweise" container="body" placement="top" [openDelay]="1000">
        Hinweise
      </ion-label>
    </ion-item-divider>
    <ion-list>
      <ion-item *ngFor="let hint of riddle.hints">
        <ion-label>
          <a (click)="editHint(hint)" [ngbTooltip]="hint.title + ': ' + hint.description" container="body" placement="top" [openDelay]="1000">
            <ion-icon name="bulb"></ion-icon> {{ hint.title }}
          </a>
          <a (click)="deleteHint(hint)">
            <ion-icon name="close"></ion-icon>
          </a>
        </ion-label>
      </ion-item>
      <ion-item *ngIf="!riddle.hints || riddle.hints.length === 0">
        <ion-label>
          <i>Keine Hinweise</i>
        </ion-label>
      </ion-item>
    </ion-list>
    <ion-button (click)="addHint()"> Hinweis hinzufügen <ion-icon name="bulb"></ion-icon></ion-button>
    <ion-item-divider>
      <ion-label>
        Dateianhänge
      </ion-label>
    </ion-item-divider>
    <ion-list>
      <ion-item *ngFor="let file of riddle.files">
        <ion-label>
          <a (click)="downloadFile(file)" [ngbTooltip]="file.name" container="body" placement="top" [openDelay]="1000">
            <ion-icon name="document"></ion-icon> {{ file.name }}
          </a>
          <a (click)="deleteFile(file)">
            <ion-icon name="close"></ion-icon>
          </a>
        </ion-label>
      </ion-item>
      <ion-item *ngIf="!riddle.files || riddle.files.length === 0">
        <ion-label>
          <i>Kein Dateianhang</i>
        </ion-label>
      </ion-item>
    </ion-list>
    <ion-progress-bar *ngIf="progress !== undefined" value="0" [value]="progress | async"></ion-progress-bar>
    <ion-button (click)="selectFile()"> Anhang hinzufügen <ion-icon name="document"></ion-icon>
    </ion-button><br>
    <ion-button color="danger" (click)="removeRiddle()">Rätsel entfernen <ion-icon name="trash"></ion-icon>
    </ion-button>

  </ion-card-content>
</ion-card>

<!-- not displayed: activated by selectFile() -->
<input type="file" #file style="display: none" (change)="onFileSelected()" />